//
//  VideoExportController.swift
//  BFRecordScreenKit_Example
//
//  Created by 胡志强 on 2021/11/25.
//  Copyright © 2021 CocoaPods. All rights reserved.
//

import Foundation
import BFRecordScreenKit
import BFUIKit
import UIKit
import AVFoundation

class VideoExportController: BFBaseViewController{
    
    var videoAsset : AVURLAsset?
    
    lazy var progressView : UIView = {
        let v = UIView(frame: CGRect(x: 10, y: 100, width: 0, height: 30))
        v.backgroundColor = .red
        return v
    }()
    
    lazy var progressL : UILabel = {
        let la = UILabel(frame: CGRect(x: 10, y: 100, width: cScreenWidth - 20, height: 30))
        la.textColor = .white
        la.text = "0%"
        la.font = UIFont.systemFont(ofSize: 18)
        return la
    }()
    
    lazy var export : BFRecordExport = {
        let export = BFRecordExport()
        
        export.progress = {[weak self] progress in
            self?.progressView.frame = CGRect(x: 10, y: 100, width: (cScreenWidth - 20) * CGFloat(progress), height: 30)
            self?.progressL.text = String(format: "%d", Int(progress*100))
        }
        export.exportCompletion = {[weak self] (error, url) in
            guard let strongSelf = self else {
                return
            }
            
            if let fileUrl = url {
                DispatchQueue.main.async {
                    let item = AVPlayerItem(url: fileUrl)
                    let avplayer = AVPlayer(playerItem: item)
                    let playerLayer = AVPlayerLayer(player: avplayer)
                    playerLayer.frame = CGRect(x: 10, y: strongSelf.progressView.bottomY+5, width: cScreenWidth - 20, height: cScreenHeigth - strongSelf.progressView.bottomY - 10)
                    strongSelf.view.layer.addSublayer(playerLayer)
                    avplayer.play()
                }
            }
        }
        return export
    }()

    override func viewDidLoad() {
        super.viewDidLoad()
        
        let backV = UIView(frame: CGRect(x: 10, y: 100, width: cScreenWidth - 20, height: 30))
        backV.backgroundColor = .gray
        view.addSubview(backV)
        view.addSubview(progressView)
        view.addSubview(progressL)

        export.start()
    }
}
